/* ----------------------------------------------------------------------------
 * Raima Database Manager 14.1.3841. [9-7-2019]
 *
 * Copyright (c) 2018 Raima Inc., All rights reserved.
 *
 * Use of this software, whether in source code format, or in executable,
 * binary object code form, is governed by the RaimaInternal LICENSE which
 * is fully described in the LICENSE.TXT file, included within this
 * distribution of files.
 * ----------------------------------------------------------------------------
 */

/* ----------------------------------------------------------------------------
 *  WARNING!  This is a machine-generated file -- do not hand edit.
 *
 *  rdmretcodetypes.h:  RDM error information
 *  Error codes are defined in file source/base/errordefns.txt
 *
 * ----------------------------------------------------------------------------
 */

/** \file rdmretcodetypes.h
 *
 *  \brief RDM Status and Error Return Codes.
 *
 *  \defgroup retcodes RDM Return Codes
 *
 *  The RDM Return codes.
 *
 *  \ingroup rdm
 *
 *  \addtogroup retcodes
 *  @{
 */

#if !defined(RDMRETCODETYPES_H_INCLUDED_)
#define RDMRETCODETYPES_H_INCLUDED_

/** 
 *  \brief RDM status and error return codes.
 */
typedef enum
{
    /* status rdbc codes: */
    sQA_RDBC_SUCCESS_WITH_INFO     =   29000, /**< A placeholder for 'SQL_SUCCESS_WITH_INFO'. */

    /* status codes: */
    sNOTFOUND                      =   10000, /**< Requested item not found. */
    sDUPLICATE                     =   10001, /**< Duplicate unique key value. */
    sTIMEOUT                       =   10002, /**< Request timed out. */
    sUPDATEDPOSITION               =   10003, /**< Row was updated and is no longer positioned at the exact same position. */
    sNOTINCURSOR                   =   10004, /**< Row was updated (unlinked) and is no longer in this cursor. */
    sTRABORTED                     =   10005, /**< Transaction was aborted by system. */
    sIGNORE                        =   10006, /**< Error can be ignored. */
    sOKAYWITHINFO                  =   10007, /**< Successful return with info. */
    sNEEDDATA                      =   10008, /**< Function requires data to be supplied. */
    sNODATA                        =   10009, /**< No data is available. */
    sENDOFCURSOR                   =   10010, /**< Reached the end of the cursor collection. */
    sEOF                           =   10011, /**< Reached the end of the file or input string. */
    sTRUNCATE                      =   10012, /**< Result is truncated. */
    sREFERENCING                   =   10013, /**< File can be read locally. */
    sFILECHANGED                   =   10014, /**< Cached file data is out of date. */
    sSKIPTRANS                     =   10015, /**< Transaction should be skipped. */
    sNOMOREPAGE                    =   10016, /**< No more page to obtain. */
    sSETCLASH                      =   10017, /**< Set pointers invalidated by another user. */
    sUPDATEABORTED                 =   10018, /**< An update transaction was aborted when closing the database. */
    sSNAPSHOTENDED                 =   10019, /**< A snapshot was closed when closing the database. */
    sREADENDED                     =   10020, /**< Read locks were freed when closing the database. */
    sTFS_SHUTDOWN                  =   10021, /**< TFS is shutting down. */
    sOPTCHANGED                    =   10022, /**< option value changed to default. */
    sCMD_USAGE                     =   10023, /**< command usage option. */
    sCMD_VERSION                   =   10024, /**< command version option. */
    sNULLVAL                       =   10025, /**< The specified column is NULL. */
    sEOS                           =   10026, /**< End of set. */
    sDBNEEDSINIT                   =   10027, /**< The database needs to be initialized. */
    sIMPROWERROR                   =   10028, /**< One or more errors occurred during import. */
    sSCHEMACHANGE                  =   10029, /**< A schema change was detected but the current operation succeeded. */
    sUNDERFLOW                     =   10030, /**< Value underflow. */
    sPRECISIONLOSS                 =   10031, /**< Lost precision for BCD calculation. */
    sNOMORERESULTS                 =   10032, /**< No additional result sets returned. */
    sFETCHBEYOND                   =   10033, /**< Attempt to fetch before the result set returned the first rowset. */
    sTRIGGERSREADONLY              =   10034, /**< The database contains triggers and rdm_dbTriggersOn() or rdm_dbTriggersOff() has not been called so the database is in read-only mode. */
    sNODB                          =   10035, /**< Database does not exist. */
    sKVNOVALUE                     =   10036, /**< The key/value pair does not have a value. */
    sOPTIONIGNORED                 =   10037, /**< The option key is valid, but is ignored for a remote TFS. */
    sCHILD                         =   10038, /**< The child process is returned from psp_serviceDaemonStart. */
    sBASE_QUEUE_CLOSED             =   10039, /**< No more messages and the queue is closed. */
    sBASE_QUEUE_EMPTY              =   10040, /**< Timed out. Queue is empty, try again later. */
    sFILE_CONSOLE                  =   10041, /**< The file is a Windows Console. Use psp_fileConsoleRead and psp_fileConsoleWrite. */
    sINDETERMINATE                 =   10042, /**< The comparison result is indeterminate. */
    sBASE_DONE                     =   10043, /**< Parsing done. */

    /* ok codes: */
    sOKAY                          =       0, /**< Normal, successful return. */

    /* fail codes: */
    eFAIL                          =      -1, /**< General failure. */

    /* general codes: */
    eNOMEMORY                      =  -10000, /**< Out of memory. */
    eREALLOCMEMORY                 =  -10001, /**< Reallocation of huge memory buffers not supported. */
    eDBNOTOPEN                     =  -10002, /**< Database not open. */
    eDBOPEN                        =  -10003, /**< Database already opened in this task. */
    eEXCLUSIVE                     =  -10004, /**< Exclusive access required. */
    eBADCAT                        =  -10005, /**< Bad catalog (error trying to read catalog file). */
    eSQLRESERVED                   =  -10006, /**< Can't use a SQL reserved word as identifier. */
    eTRACTIVE                      =  -10007, /**< Transaction is active. */
    eNOUPDATE                      =  -10008, /**< Transaction handle does not refer to an update transaction. */
    eTRNOTACT                      =  -10009, /**< Transaction not active. */
    eNOSTART                       =  -10010, /**< No rdm_dbStartRead(), rdm_dbStartSnapshot(), or rdm_dbStartUpdate() is active. */
    eNOSTARTUPDATE                 =  -10011, /**< An update operation was attempted when no rdm_dbStartUpdate() is active. */
    eNOSTARTREAD                   =  -10012, /**< A read operation was attempted when no rdm_dbStartSnapshot(), rdm_dbStartRead(), or rdm_dbStartUpdate() is active. */
    eNOTLOCKED                     =  -10013, /**< Attempt to access a table for reading or update without proper locks. */
    eNOTFREE                       =  -10014, /**< Attempt to lock already locked table. */
    eDUPLICATE                     =  -10015, /**< Attempt to insert a duplicate value as a unique/primary key. */
    eREFINTEGRITY                  =  -10016, /**< Integrity constraint violation. */
    eCHECK                         =  -10017, /**< Check clause violation. */
    eNODB                          =  -10018, /**< Database not found. */
    eSNAPSHOTACTIVE                =  -10019, /**< Snapshot is active. */
    eSNAPSHOTNOTACTIVE             =  -10020, /**< Snapshot is not active. */
    eOPENMODE                      =  -10021, /**< Invalid db open mode. */
    eNOTIMPLEMENTED                =  -10022, /**< Function/feature not implemented. */
    eINVFCNARG                     =  -10023, /**< Invalid function argument. */
    eINVNULLARG                    =  -10024, /**< Function argument cannot be NULL. */
    eINVFCNSEQ                     =  -10025, /**< Function sequence error. */
    eINVLITERAL                    =  -10026, /**< Invalid literal constant specification. */
    eMISSINGLITERAL                =  -10027, /**< Syntax error where we expected a literal constant specification. */
    eCIRTABDELETE                  =  -10028, /**< Cannot delete rows from a circular table. */
    eNOTNULL                       =  -10029, /**< Must specify value for column. */
    eFILEIO                        =  -10030, /**< File I/O error. */
    eFILEOPEN                      =  -10031, /**< Unable to open file. */
    eFILEACCESS                    =  -10032, /**< Unable to open file due to access restrictions. */
    eFILEEXIST                     =  -10033, /**< Unable to create file due to an already existing file. */
    eFILENOENTRY                   =  -10034, /**< Unable to open file since it does not exist. */
    eFILEISDIR                     =  -10035, /**< File is a directory. */
    eEOF                           =  -10036, /**< Reached the end of the file or input string. */
    eBROKENPIPE                    =  -10037, /**< Failed to read or write since the other end have closed the connection. */
    eUNOMISMATCH                   =  -10038, /**< Unions mismatch . */
    eNOSPACE                       =  -10039, /**< Out of disk space. */
    ePRECOMMITTED                  =  -10040, /**< A precommitted transaction must be committed or rolled back before further operations on this database are allowed. */
    eINVDBNAMESPEC                 =  -10041, /**< Invalid database name specification. */
    eINVTFSSPEC                    =  -10042, /**< Invalid TFS specification. */
    eFILEINUSE                     =  -10043, /**< File in use. */
    eTRUNCATED                     =  -10044, /**< Date truncated. */
    eBADREAD                       =  -10045, /**< Error reading from a file. */
    eBADWRITE                      =  -10046, /**< Error writing to a file. */
    eRANGE                         =  -10047, /**< Numeric value out of range. */
    eINVKEYVALUE                   =  -10048, /**< Invalid key/value pair. */
    eINVBCD                        =  -10049, /**< Invalid BCD value. */
    eINVBOUNDARYVAL                =  -10050, /**< Invalid R-tree boundary value. */
    eDUPUSERID                     =  -10051, /**< DBUSERID is already in use. */
    eREADONLY                      =  -10052, /**< Database is read-only and cannot be updated. */
    eMKDIR                         =  -10053, /**< Unable to create directory. */
    eRECOVERYFAILED                =  -10054, /**< Recovery failed. */
    eNOTFOUND                      =  -10055, /**< Not found. */
    eSYNTAX                        =  -10056, /**< Syntax error. */
    eBADDATALEN                    =  -10057, /**< Invalid string or buffer length. */
    eINVROWIDVAL                   =  -10058, /**< Invalid rowid value. */
    eVALUEISLIST                   =  -10059, /**< Attempted to retrieve a single value where the actual value is a list. */
    eINVVARINT                     =  -10060, /**< Invalid variable integer value. */
    eDATALOST                      =  -10061, /**< Significant data lost due to truncation. */
    eINVBINLITERAL                 =  -10062, /**< Invalid binary literal specification. */
    eTYPEMISMATCH                  =  -10063, /**< Data type mismatch. */
    eROWIDRANGE                    =  -10064, /**< RowId value out of range. */
    eROWIDMISMATCH                 =  -10065, /**< The specified RowId does not match the Primary Key RowId value. */
    eROWLIMIT                      =  -10066, /**< Table row limit reached. */
    eINVCONVERT                    =  -10067, /**< Invalid data type conversion. */
    eINVUTF                        =  -10068, /**< Invalid UTF string. */
    eINVOPTION                     =  -10069, /**< Invalid option is specified. */
    eINVOPTIONVALUE                =  -10070, /**< Invalid option value. */
    eDBNOTCLOSED                   =  -10071, /**< Option requires database to be closed. */
    eINVARG                        =  -10072, /**< Invalid argument. */
    eINVARGTYPE                    =  -10073, /**< Invalid argument type. */
    eINVTRID                       =  -10074, /**< Invalid transaction id. */
    eNOTSUPPORTED                  =  -10075, /**< Function not supported. */
    eNOTROOTUPDATETRANS            =  -10076, /**< You can only precommit the root update transaction. */
    eESCAPE                        =  -10077, /**< Escape clause syntax error. */
    eSTRTOOLONG                    =  -10078, /**< String literal too long. */
    eDBEXISTS                      =  -10079, /**< Database already exists. */
    eEOD                           =  -10080, /**< Insufficient data. */
    eINVID                         =  -10081, /**< Invalid 'internals' id. */
    eINVUNICODE                    =  -10082, /**< Invalid Unicode string. */
    eCOLCOUNTMISMATCH              =  -10083, /**< Invalid number column values provided for the table. */
    eKEYCOLCOUNTMISMATCH           =  -10084, /**< Invalid number column values provided for the key. */
    eHASMEMBERS                    =  -10085, /**< Referential Integrity error - row is referenced by other rows. */
    eDEPRECATED                    =  -10086, /**< This feature is deprecated. */
    eINVTIMEOUT                    =  -10087, /**< Invalid timeout value. */
    eLEGACYAPI                     =  -10088, /**< Call to a legacy API from a database handle not opened in legacy mode. */
    eLEGACYDB                      =  -10089, /**< Call non-legacy API from a database handle opened in legacy mode. */
    eINMEMMISMATCH                 =  -10090, /**< Attempting to open a database that is already open with differing in-memory options. */
    eBADWILDALL                    =  -10091, /**< Bad wild all character (must be '%' or '*'). */
    eBADWILDONE                    =  -10092, /**< Bad wild one character (must be '_', '.', or '?'). */
    eBADSNAPSHOTMODE               =  -10093, /**< Invalid snapshot mode. */
    eINVHANDLE                     =  -10094, /**< Invalid handle. */
    eINVSQLTYPE                    =  -10095, /**< Invalid SQL data type. */
    eCONNNOTOPEN                   =  -10096, /**< Connection is not open. */
    eDIVBY0                        =  -10097, /**< Division by zero. */
    eNOTANUMBER                    =  -10098, /**< A calculation returned not a number. */
    eINVALID                       =  -10099, /**< Invalid encoding. */
    eUNAVAIL                       =  -10100, /**< Requested resource not available. */
    eTABNOTFOUND                   =  -10101, /**< Table not declared. */
    eCOLNOTFOUND                   =  -10102, /**< Column not declared. */
    eINSERTVALS                    =  -10103, /**< Insert value list does not match column list. */
    eINVTRIGSTMT                   =  -10104, /**< Prohibited statement encountered during trigger execution. */
    eNOSTATS                       =  -10105, /**< No statistics is associated with this database. */
    eDROPONLYCOL                   =  -10106, /**< Illegal attempt to drop the only column of the table. */
    eTFSOPTIONALLOC                =  -10107, /**< Option specified can only be specified when allocating a TFS. */
    eOPTIONINCOMPAT                =  -10108, /**< Invcompatible option values. */
    eINVINFOKEY                    =  -10109, /**< Invalid information key value. */
    eDBCORRUPTED                   =  -10110, /**< Database corruption. */
    eDROPTRIGCOL                   =  -10111, /**< Illegal attempt to drop a column referenced by trigger. */

    /* base codes: */
    eBASE_INVDATE                  =  -11000, /**< Invalid date value. */
    eBASE_INVTIMEZONE              =  -11001, /**< Invalid time zone value. */
    eBASE_COMMAND                  =  -11002, /**< Command line argument processor error. */
    eBASE_QUEUE_CLOSED             =  -11003, /**< No more messages can be written since the queue is closed. */
    eBASE_SYNTAX                   =  -11004, /**< Syntax error. */

    /* core codes: */
    eDEFUNCT                       =  -12000, /**< Function no longer supported/defunct. */
    eINVTASKID                     =  -12001, /**< Invalid task id. */
    eINVDBID                       =  -12002, /**< Invalid db id. */
    eINVCURSORID                   =  -12003, /**< Invalid cursor id. */
    eINVTRANSID                    =  -12004, /**< Invalid transaction id. */
    eNOTRANSID                     =  -12005, /**< No transaction id specified. */
    eCURSORDB                      =  -12006, /**< Cursor is associated with a different database. */
    eINVTFSID                      =  -12007, /**< Invalid TFS id. */
    eINVFORUNION                   =  -12008, /**< Invalid operation on unioned db. */
    eNOTKEY                        =  -12009, /**< Column is not a key. */
    eNOTBLOB                       =  -12010, /**< Column is not a BLOB or CLOB. */
    eINVLOCKTYPE                   =  -12011, /**< Invalid lock type. */
    eINVKEYID                      =  -12012, /**< Invalid key id. */
    eKEYREQD                       =  -12013, /**< Key value required. */
    eINVCOLID                      =  -12014, /**< Invalid column id. */
    eINVTABID                      =  -12015, /**< Invalid table id. */
    eINVREFID                      =  -12016, /**< Invalid reference (set) id number. */
    eINVIDENTIFIER                 =  -12017, /**< Invalid id value. */
    eINVCURSOROP                   =  -12018, /**< Invalid operation for this cursor. */
    eDELETED                       =  -12019, /**< The current row has been deleted. */
    eOWNERDELETED                  =  -12020, /**< The owner row for a set cursor has been deleted. */
    eSINGLETONDELETED              =  -12021, /**< The row for a singleton cursor has been deleted. */
    eNOTOWNER                      =  -12022, /**< The cursor's rows are not owners of the specified set. */
    eNOTMEMBER                     =  -12023, /**< The cursor's rows are not members of the specified set. */
    eNOTRELATED                    =  -12024, /**< Items are not related. */
    eNOCURRENTROW                  =  -12025, /**< The cursor is not positioned to a valid row. */
    eNOCURRENTOWNER                =  -12026, /**< No current owner row. */
    eNOCURRENTMEMBER               =  -12027, /**< No current member row. */
    eNOTLINKED                     =  -12028, /**< The cursor is positioned to a row that is not linked to the specified reference id. */
    eINVITERATION                  =  -12029, /**< Invalid attempt to move cursor before 'BeforeFirst' or past 'AfterLast'. */
    eLOSTPOSITION                  =  -12030, /**< Cursor position was lost and must be reset. */
    eINVCURSORCOL                  =  -12031, /**< The specified column is not in the table the cursor is associated with. */
    eINVCURSORKEY                  =  -12032, /**< The specified key is not in the table the cursor is associated with. */
    eNOTINCURSOR                   =  -12033, /**< The row is not in the cursor. */
    eBLOBBADSIZE                   =  -12034, /**< Not enough data in the blob to satisfy the read request. */
    eBLOBBADPOSITION               =  -12035, /**< Invalid blob offset position. */
    eHASOWNER                      =  -12036, /**< The row references other rows. */
    eISOWNED                       =  -12037, /**< The member row is already owned. */
    eEOS                           =  -12038, /**< End of set. */
    eISCOMPOUNDKEY                 =  -12039, /**< Column is a compound key. */
    eCOMPOUNDKEY                   =  -12040, /**< Column is in a compound key. */
    eKEYERR                        =  -12041, /**< Key inconsistency detected. */
    eKEYSEQ                        =  -12042, /**< Field type used out of sequence in d_keynext. */
    eVARDATALEN                    =  -12043, /**< Vardata length inconsistency. */
    eVARDATAPTR                    =  -12044, /**< Vardata pointer inconsistency. */
    eTRFREE                        =  -12045, /**< Attempt to free a lock inside a transaction. */
    eBADLOCKS                      =  -12046, /**< Inconsistent database locks. */
    eINUPDATE                      =  -12047, /**< Initialize not allowed when a rdm_dbStartUpdate() is active. */
    eININIT                        =  -12048, /**< Updates not allowed when an initialization is in progress. */
    eINVKEYSPEC                    =  -12049, /**< Invalid key specification. */
    eREADONLYCURSOR                =  -12050, /**< Cursor is read-only. */
    eSLAVEREADONLY                 =  -12051, /**< Attempted to open a slave database in non-readonly mode. */
    eDEBUG                         =  -12052, /**< Debugging check interrupt. */
    eINVENCRYPT                    =  -12053, /**< Invalid encryption key. */
    eENCRYPTMISMATCH               =  -12054, /**< Encryption passcodes do not match. */
    eSETPAGES                      =  -12055, /**< Error in d_setpages (database open or bad param). */
    eINVFILE                       =  -12056, /**< Invalid file type for operation. */
    eREP_INVOP                     =  -12057, /**< Invalid operation during replication. */
    eDBDREAD                       =  -12058, /**< Error reading dbd file. */
    eINVENDIAN                     =  -12059, /**< Invalid endian format. */
    eINVSTRING                     =  -12060, /**< Invalid string format. */
    eINVDBA                        =  -12061, /**< Invalid dba format. */
    eCATMISMATCH                   =  -12062, /**< Catalog in memory does not match Catalog on disk. */
    eSCHEMACHANGE                  =  -12063, /**< A schema change was detected and the current operation was not successful. */
    eDBD_NONAMES                   =  -12064, /**< Incompatible legacy DBD file - does not contain record/field/set name. */
    eNOT_ENCRYPTED                 =  -12065, /**< The database is not encrypted. */
    eREPLOG_ERROR                  =  -12066, /**< Error processing/reading/creating/writing the replication log. */
    eREPLOG_EOF                    =  -12067, /**< EOF for replication log file. */
    eINVDB                         =  -12068, /**< Invalid database. */
    eIMPBADXML                     =  -12069, /**< Bad xml. */
    eIMPBADDATA                    =  -12070, /**< Bad data. */
    eMULTIPLE_DBS                  =  -12071, /**< Open multiple dbs in one call is not supported by this API, use multiple calls. */
    eUNIONCATMISMATCH              =  -12072, /**< Unioned databases do not have compatible Catalog structures. */
    eINCOMPAT                      =  -12073, /**< Incompatible dictionary file. */
    eINVOPFORBLOB                  =  -12074, /**< Invalid operation for a BLOB column. */
    eINVOPENMODE                   =  -12075, /**< Invalid database open mode. */
    eDBOPENED                      =  -12076, /**< Operation not completed because database is open. */
    eNOCURRTYPE                    =  -12077, /**< No current table type. */
    eTABLEISINREF                  =  -12078, /**< Cannot quick initialize the table because the table is involved in a reference. */
    eNOCOLUMNVALUE                 =  -12079, /**< No column value was specified, the column do not have a default, and cannot be null. */
    eNULLCOLUMNVALUE               =  -12080, /**< NULL column value was specified, the column cannot be null. */
    eINVDATEFMT                    =  -12081, /**< Invalid date format. */
    eINVDATESEP                    =  -12082, /**< Invalid date separator. */
    eINVTIMEFMT                    =  -12083, /**< Invalid time format. */
    eVTNOTREGISTERED               =  -12084, /**< Reference to unregistered Virtual Table. */
    eMIXEDTRANS                    =  -12085, /**< DDL and DML transactions cannot be mixed. */
    eINVLOCALE                     =  -12086, /**< Invalid collation locale. */
    eLOCALEMISMATCH                =  -12087, /**< Attempt to open database with incorrect (or no) locale. */
    eNOTRTREE                      =  -12088, /**< The key specified is not an rtree index. */
    eISRTREE                       =  -12089, /**< The key specified is an rtree index. */
    eDROPPED                       =  -12090, /**< Attempt to access a cursor based on an item that has been dropped. */

    /* tfs codes: */
    eTFS_INVHANDLE                 =  -13000, /**< Invalid TFS handle. */
    eTFS_INVTYPE                   =  -13001, /**< Invalid TFS type. */
    eTFS_NOTINITIALIZED            =  -13002, /**< The RDM Transaction File Server (TFS) is not initialized. */
    eTFS_DUPUSER                   =  -13003, /**< Duplicate user ID. */
    eTFS_FCNSEQ                    =  -13004, /**< Function sequence error. */
    eTFS_ILLEGALMOD                =  -13005, /**< Illegal attempt to modify file(s) on read-only device. */
    eTFS_ILLEGALACCESS             =  -13006, /**< Illegal attempt to access file(s) on diskless system. */
    eTFS_INVDBID                   =  -13007, /**< Invalid db id. */
    eTFS_INVUSERID                 =  -13008, /**< Invalid user id. */
    eTFS_INVIDINDEX                =  -13009, /**< Invalid ID index file. */
    eTFS_IDINDEXOFFSET             =  -13010, /**< The offset into the pack is greater than the ID Index can handle. */
    eTFS_IDINDEXLENGTH             =  -13011, /**< The row, bucket, or index node in the pack is larger than the ID Index can handle. */
    eTFS_DOCROOTUSED               =  -13012, /**< The specified docroot is already in use. */
    eTFS_DOCROOTNOTFOUND           =  -13013, /**< The specified docroot location is not found. */
    eTFS_DOCROOTINVALID            =  -13014, /**< The specified docroot location is invalid. */
    eTFS_WRITEFAIL                 =  -13015, /**< Failed to write to a file. */
    eTFS_INVFILE                   =  -13016, /**< File not found in file table. */
    eTFS_IASYNC_ON                 =  -13017, /**< Internal asynchronous mode is enabled. */
    eTFS_BLOCKED                   =  -13018, /**< Mirroring is blocking transactions. */
    eTFS_INVOPERATION              =  -13019, /**< Invalid operation for this type of TFS. */
    eTFS_NOTRANS                   =  -13020, /**< Transaction not active. */
    eTFS_DBOPEN                    =  -13021, /**< Cannot destroy a database that is open by others. */
    eTFS_NOPAGE                    =  -13022, /**< Requested page doesn't exist. */
    eTFS_COMMITFAILED              =  -13023, /**< Commit failed due to prelog file rename failure. */
    eTFS_DBINUSE                   =  -13024, /**< Database is currently in use. */
    eTFS_INIEDITED                 =  -13025, /**< Attempted to edit an INI when it is already being edited. */
    eTFS_ININOTEDITED              =  -13026, /**< Attempted to edit an INI that was not held for editing. */
    eTFS_NAMEINUSE                 =  -13027, /**< Name or port already in use. */
    eTFS_NOMIR                     =  -13028, /**< Replication/mirroring is not enabled for this TFS library. */
    eTFS_NOSQL                     =  -13029, /**< SQL is not enabled for this TFS library. */
    eTFS_NOTFS                     =  -13030, /**< TFS is not enabled for this TFS library. */
    eTFS_CONNECT                   =  -13031, /**< Failed to connect to TFS. */
    eTFS_ENCNOTINIT                =  -13032, /**< Encryption subsystem is not initialized on the TFS. */

    /* psp codes: */
    ePSP_FAILURE                   =  -14000, /**< General failure in the PSP library. */
    ePSP_MUTEX_FAILURE             =  -14001, /**< Mutex failure in the PSP library. */
    ePSP_PRIV                      =  -14002, /**< Insufficient privilege. */
    ePSP_INVUSER                   =  -14003, /**< Invalid user. */
    ePSP_INVPASS                   =  -14004, /**< Invalid password. */
    ePSP_NOSOURCE                  =  -14005, /**< Invalid source. */
    ePSP_NODEST                    =  -14006, /**< Invalid destination. */
    ePSP_INVUUID                   =  -14007, /**< Invalid UUID in the PSP library. */
    ePSP_DEADLOCK                  =  -14008, /**< Mutex deadlock in the PSP library. */

    /* ddl codes: */
    eDDL_SYNTAX                    =  -14500, /**< Syntax error. */
    eDDL_CRDBACTIVE                =  -14501, /**< A CREATE/ALTER DATABASE is already active. */
    eDDL_WRONGDB                   =  -14502, /**< Table must be created in the active database. */
    eDDL_DUPCOLUMN                 =  -14503, /**< Column with same name already declared in table. */
    eDDL_NOTWITHDOMAIN             =  -14504, /**< Not allowed with columns declared with domain. */
    eDDL_DOMNOTFOUND               =  -14505, /**< Domain not declared. */
    eDDL_BADDATATYPE               =  -14506, /**< Invalid data type. */
    eDDL_DUPTABNAME                =  -14507, /**< Duplicate table name. */
    eDDL_DUPCOLNAME                =  -14508, /**< Duplicate column name. */
    eDDL_FKMISMATCH                =  -14509, /**< Foreign/primary key columns do not match. */
    eDDL_REFNULL                   =  -14510, /**< A referenced key must have at least one NOT NULL column. */
    eDDL_NOPRIKEY                  =  -14511, /**< Referenced table does not have referenced primary key. */
    eDDL_DEFAUTO                   =  -14512, /**< DEFAULT AUTO is not allowed (only with guid/rowid type). */
    eDDL_DEFCURRENT                =  -14513, /**< DEFAULT CURRENT is not allowed (only with date/time types). */
    eDDL_BADVARPREC                =  -14514, /**< Invalid variable length column precision. Must be > 0. */
    eDDL_VARCHARLEN                =  -14515, /**< Must specify '(length)' with variable size columns. */
    eDDL_BINLEN                    =  -14516, /**< Must specify '(length)' with binary columns. */
    eDDL_NOMAXROWS                 =  -14517, /**< Must specify 'MAXROWS=value' with circular tables. */
    eDDL_MAXROWSVALUE              =  -14518, /**< MAXROWS value must be >0. */
    eDDL_CONSTRNAME                =  -14519, /**< Constraint name used more than once. */
    eDDL_NULLCONFLICT              =  -14520, /**< NOT NULL constraint specified for a column that has NULL values or a NULL default value. */
    eDDL_DROPCOLUMN                =  -14521, /**< Cannot DROP COLUMN: column is used in constraint--drop constraint first. */
    eDDL_DROPNOTNULL               =  -14522, /**< Cannot DROP NOT NULL: column is not defined as NOT NULL. */
    eDDL_ALTERCHECK                =  -14523, /**< CHECK constraint not allowed in ALTER COLUMN. */
    eDDL_CONSTRNOTFOUND            =  -14524, /**< Constraint not found. */
    eDDL_NOREFDTABLE               =  -14525, /**< Referenced table not found. */
    eDDL_COLDOMCONSTR              =  -14526, /**< Column constraint defined in domain. */
    eDDL_DROPREFDKEY               =  -14527, /**< Cannot drop a referenced unique/primary key. */
    eDDL_FKCOLINFK                 =  -14528, /**< A column can only be used in one foreign key. */
    eDDL_ALTERTYPE                 =  -14529, /**< Cannot change column to specified data type. */
    eDDL_NEEDTABLE                 =  -14530, /**< Table name must be specified. */
    eDDL_DROPTABLE                 =  -14531, /**< Cannot drop table referenced by a foreign key. */
    eDDL_DROPFKCOL                 =  -14532, /**< Cannot drop a foreign key on a column used in a key--drop key first. */
    eDDL_DROPDOMAIN                =  -14533, /**< Cannot drop a domain that is being used by a column. */
    eDDL_DOMAINCHECK               =  -14534, /**< Cannot specify a CHECK clause for a column declared as domain type. */
    eDDL_DBEXISTS                  =  -14535, /**< Database already exists. */
    eDDL_CONDEXPR                  =  -14536, /**< Invalid conditional expression spec. */
    eDDL_DISPLAY                   =  -14537, /**< Invalid DISPLAY clause spec. */
    eDDL_COLTYPE                   =  -14538, /**< Column declarations must begin with name followed by type. */
    eDDL_COLDECL                   =  -14539, /**< Invalid column declaration spec. */
    eDDL_COLCONSTRAINT             =  -14540, /**< Invalid column constraint spec. */
    eDDL_TABCONSTRAINT             =  -14541, /**< Invalid table constraint spec. */
    eDDL_INDEXMETHOD               =  -14542, /**< Invalid USING index method. */
    eDDL_ORDERBY                   =  -14543, /**< Invalid ORDER BY spec. */
    eDDL_ONACTION                  =  -14544, /**< Invalid ON UPDATE/DELETE action spec. */
    eDDL_KEYSPEC                   =  -14545, /**< Invalid key spec. */
    eDDL_FORKEYSPEC                =  -14546, /**< Invalid foreign key/references spec. */
    eDDL_ERRORS                    =  -14547, /**< DDL errors were found. */
    eDDL_ALTERCOL                  =  -14548, /**< Invalid ALTER COLUMN spec. */
    eDDL_NOARRAYS                  =  -14549, /**< Arrays are not allowed with this data type. */
    eDDL_NOBLOBS                   =  -14550, /**< Blobs not allowed in virtual tables. */
    eDDL_ALTERACT                  =  -14551, /**< Invalid ALTER action spec. */
    eDDL_HASPRIKEY                 =  -14552, /**< Table already has a primary key defined. */
    eDDL_NOLOBKEYS                 =  -14553, /**< Large object columns cannot be keyed. */
    eDDL_NODBNAME                  =  -14554, /**< Default database name not provided. */
    eDDL_INVDEF                    =  -14555, /**< Invalid default specification for the type. */
    eDDL_NOHASHORDER               =  -14556, /**< Column orders are not allowed on a hash index. */
    eDDL_BADRTREECOLS              =  -14557, /**< Only one array column allowed for a R-tree index. */
    eDDL_BADRTREELEN               =  -14558, /**< The array size for an R-tree index must be 2, 4, or 6. */
    eDDL_NONUNIQUEHASH             =  -14559, /**< Hash index must be unique. */
    eDDL_TABREFFEDINPL             =  -14560, /**< Cannot drop a table referenced in a procedure or trigger on another table. */
    eDDL_COLWITHDEFVAL             =  -14561, /**< Cannot add a column with the default value to a table that has rows. */
    eDDL_INVCHGFORKEY              =  -14562, /**< Cannot change a foreign key constaint when the key columns have non-null values. */

    /* sql codes: */
    eSQL_SQLERROR                  =  -15000, /**< Internal SQL error. */
    eSQL_DUPCURSOR                 =  -15001, /**< Duplicate cursor name. */
    eSQL_GENFILE                   =  -15002, /**< Unable to open file. */
    eSQL_BADFORMAT                 =  -15003, /**< Bad formatting specification. */
    eSQL_COLNUMBER                 =  -15004, /**< Invalid descriptor index (column number). */
    eSQL_PARNUMBER                 =  -15005, /**< Invalid descriptor index (parameter number). */
    eSQL_RDMERROR                  =  -15006, /**< RDM runtime error. */
    eSQL_SELECTCOLS                =  -15007, /**< SELECT result columns do not match column list. */
    eSQL_NOCOLUMN                  =  -15008, /**< Column not found. */
    eSQL_NUMPAR                    =  -15009, /**< Insufficient number of parameters specified. */
    eSQL_FETCHTYPE                 =  -15010, /**< Fetch type out of range. */
    eSQL_ROWVALUE                  =  -15011, /**< Row value out of range. */
    eSQL_CURPOS                    =  -15012, /**< Invalid cursor position. */
    eSQL_NOSETATTR                 =  -15013, /**< Attribute cannot be set now. */
    eSQL_CURSTATE                  =  -15014, /**< Invalid cursor state. */
    eSQL_NOTSELECT                 =  -15015, /**< Current/cursor's statement is not SELECT. */
    eSQL_ESCAPECHAR                =  -15016, /**< Invalid escape character. */
    eSQL_INVSTATE                  =  -15017, /**< Invalid statement state. */
    eSQL_WHERECALCS                =  -15018, /**< Aggregate functions not allowed in WHERE. */
    eSQL_INVPARAM                  =  -15019, /**< Invalid use of parameter marker. */
    eSQL_DUPPROC                   =  -15020, /**< Duplicate stored procedure name. */
    eSQL_NOPROC                    =  -15021, /**< Stored procedure/function not found. */
    eSQL_NUMARGS                   =  -15022, /**< Invalid number of arguments specified. */
    eSQL_BADOUTERJOIN              =  -15023, /**< No access path between outer joined tables. */
    eSQL_HDBCINUSE                 =  -15024, /**< Connection already in use. */
    eSQL_UDF                       =  -15025, /**< User-defined function error. */
    eSQL_NORETURNVAL               =  -15026, /**< No result value returned from function. */
    eSQL_UDFDEFN                   =  -15027, /**< UDFLOADTABLE entry definition error. */
    eSQL_UDFARG                    =  -15028, /**< Invalid function argument type. */
    eSQL_UDFNOARGS                 =  -15029, /**< Incorrect number of function arguments. */
    eSQL_INSERTCOLREF              =  -15030, /**< Invalid column reference in INSERT expression. */
    eSQL_DUPJOINCOL                =  -15031, /**< Duplicate join column. */
    eSQL_NOJOINCOLMATCH            =  -15032, /**< No matching join columns. */
    eSQL_SORTCOLREF                =  -15033, /**< Invalid order/group by column reference. */
    eSQL_FCNARG                    =  -15034, /**< Invalid function argument. */
    eSQL_NUMFCNARGS                =  -15035, /**< Invalid number of specified function arguments. */
    eSQL_INVSTMT                   =  -15036, /**< Invalid statement type. */
    eSQL_CANCELLED                 =  -15037, /**< Statement execution cancelled by user. */
    eSQL_GROUPBYAGGFN              =  -15038, /**< Aggregate functions not allowed in GROUP BY. */
    eSQL_TXUNKNOWN                 =  -15039, /**< Transaction state unknown. */
    eSQL_NOTPREPARED               =  -15040, /**< Associated statement is not prepared. */
    eSQL_INVTXTYPE                 =  -15041, /**< Invalid transaction operation code. */
    eSQL_PARMTYPE                  =  -15042, /**< Invalid parameter type. */
    eSQL_TIMEOUT                   =  -15043, /**< Timeout expired. */
    eSQL_IEF                       =  -15044, /**< Import/export error. */
    eSQL_REMOTEERROR               =  -15045, /**< JNI/ADO.Net system error. */
    eSQL_COMERROR                  =  -15046, /**< RPC communication error. */
    eSQL_LOCKSACTIVE               =  -15047, /**< Operation not allowed due to active read locks. */
    eSQL_MULTIDBTRANS              =  -15048, /**< Multiple database transactions are not allowed. */
    eSQL_NOTUPDATEABLE             =  -15049, /**< SELECT or column is not updateable. */
    eSQL_BLOBEXPR                  =  -15050, /**< Blobs cannot be referenced in expressions. */
    eSQL_DATAATEXEC                =  -15051, /**< Data-at-exec params only allowed with INSERT VALUES/UPDATE. */
    eSQL_BLOBPARSONLY              =  -15052, /**< Data-at-exec params only allowed for blob (long var...) columns. */
    eSQL_BADBLOBPAR                =  -15053, /**< Data-at-exec param type not compatible with blob (long var...) column. */
    eSQL_LOCKMODE                  =  -15054, /**< Illegal locking mode. */
    eSQL_NOUPDCOLS                 =  -15055, /**< No columns have been updated. */
    eSQL_AUTOCOMMIT                =  -15056, /**< Operation not allowed when autocommit is enabled. */
    eSQL_CURSORTABLE               =  -15057, /**< Positioned UPDATE/DELETE table does not match cursor's. */
    eSQL_RDONLYFLAG                =  -15058, /**< Inconsistent read-only transaction commit/rollback/end call. */
    eSQL_TABLEREF                  =  -15059, /**< Duplicate table reference in FROM clause. */
    eSQL_NESTEDAGGS                =  -15060, /**< Cannot call an aggregate function within an aggregate function. */
    eSQL_CHARREQD                  =  -15061, /**< CHAR type is required. */
    eSQL_CONNECT                   =  -15062, /**< Unable to connect. */
    eSQL_UNIONOPEN                 =  -15063, /**< Database union open invalid when other database is open. */
    eSQL_NOBLOBSORT                =  -15064, /**< Sorting on a blob column is not allowed. */
    eSQL_NOBLOBGROUP               =  -15065, /**< Blob columns cannot be referenced in a SELECT with GROUP BY. */
    eSQL_DIFFCONNS                 =  -15066, /**< Statements from different connections. */
    eSQL_OUTERJOIN                 =  -15067, /**< Unable to process outer join specification. */
    eSQL_NOWHEREBLOB               =  -15068, /**< Blob columns cannot be used in WHERE clause of a SELECT with ORDER BY. */
    eSQL_NAMEDPARAM                =  -15069, /**< Named parameter not found. */
    eSQL_NOTINUDF                  =  -15070, /**< Function cannot be called from a UDF. */
    eSQL_GROUPRESULT               =  -15071, /**< Result column must have aggregate function call. */
    eSQL_INVCURSOR                 =  -15072, /**< Invalid cursor name. */
    eSQL_CURSORTAB                 =  -15073, /**< Target table does not match cursor specification. */
    eSQL_FORUPDCOL                 =  -15074, /**< FOR UPDATE column not in SELECT list. */
    eSQL_INVPROC                   =  -15075, /**< Stored procedure has an invalid version. */
    eSQL_NOTUDFAGG                 =  -15076, /**< DISTINCT can only be specified with aggregate UDF. */
    eSQL_INVFILETYPE               =  -15077, /**< Invalid import/export file type. */
    eSQL_INVROWIDVAL               =  -15078, /**< Invalid rowid value. */
    eSQL_NOINSERTID                =  -15079, /**< No last_insert_id is available. */
    eSQL_INVSELECT                 =  -15080, /**< SELECT cannot have ORDER/GROUP BY clause. */
    eSQL_UPDROWIDPK                =  -15081, /**< UPDATE of rowid primary key column is not allowed. */
    eSQL_GROUPBYPARMS              =  -15082, /**< GROUP BY column expressions cannot have parameter markers. */
    eSQL_INVARMISMATCH             =  -15083, /**< Variant argument value in INVAR aggregate function. */
    eSQL_SORTCOST                  =  -15084, /**< Sort cost factor must be > 0.0 and < 1.0. */
    eSQL_CACHESIZE                 =  -15085, /**< Cache size setting must be >= 100. */
    eSQL_DEBUGMODE                 =  -15086, /**< Valid debug mode values are 0,1,2,3. */
    eSQL_BADSCALE                  =  -15087, /**< Invalid DECIMAL scale. Must be >= 0 and <= prec. */
    eSQL_TOOMANYROWS               =  -15088, /**< Subquery returns more than 1 row. */
    eSQL_AMBIGUOUSCOLREF           =  -15089, /**< Column with this name declared in more than one of the referenced tables. */
    eSQL_NOHIDDENCOLS              =  -15090, /**< Hidden columns not allowed in this context. */
    eSQL_ROWNUMBER                 =  -15091, /**< ROWNUMBER() can only be used with a SELECT statement. */
    eSQL_LABELMISMATCH             =  -15092, /**< END label missing or doesn't match block label. */
    eSQL_UNDECLAREDVARREF          =  -15093, /**< Reference to undeclared variable. */
    eSQL_NOAGGINASGT               =  -15094, /**< Aggregate functions not allowed in assignment statement. */
    eSQL_PROCGLOBALREF             =  -15095, /**< Stored procedure references an undeclared global variable. */
    eSQL_NOVALGLOBAL               =  -15096, /**< No value assigned to the global variable. */
    eSQL_INARGASGT                 =  -15097, /**< Assignment to input only argument or condition. */
    eSQL_OUTARGCALL                =  -15098, /**< Output argument must map to a variable. */
    eSQL_NOOERRCODE                =  -15099, /**< Sqlstate/error/condition code not defined. */
    eSQL_CASENOTFOUND              =  -15100, /**< Case not found for CASE statement. */
    eSQL_OUTARGS                   =  -15101, /**< INOUT/OUT arguments are not allowed in functions. */
    eSQL_INVRETURN                 =  -15102, /**< RETURN statements are not allowed in procedures. */
    eSQL_RESULTSET                 =  -15103, /**< Cursors/SELECTs that return result sets are not allowed in handlers, functions or triggers. */
    eSQL_RETURNTYPE                =  -15104, /**< Data type of RETURN expression is not compatible with function. */
    eSQL_ALIASEDCOLSREQD           =  -15105, /**< All result column expressions must be aliased in DECLARE CURSOR's SELECT. */
    eSQL_CURNOTDECLARED            =  -15106, /**< Cursor not declared. */
    eSQL_USEINPROCONLY             =  -15107, /**< FOUND test can only be used in stored procedure/function. */
    eSQL_FETCHVARS                 =  -15108, /**< FETCH INTO variable list cursor column count mismatch. */
    eSQL_FETCHVARDATATYPE          =  -15109, /**< FETCH INTO variable data type incompatible with corresponding result column type. */
    eSQL_NORESULTSETS              =  -15110, /**< WITH RETURN cursor not allowed with this procedure (DYNAMIC RESULT SETS = 0). */
    eSQL_DUPVARREF                 =  -15111, /**< Variable is already declared. */
    eSQL_NOTROWVAR                 =  -15112, /**< Identifier is not a declared row variable or BEGIN label. */
    eSQL_ROWVARREF                 =  -15113, /**< Illegal row variable reference. */
    eSQL_GLOBALVARREF              =  -15114, /**< Illegal global variable reference. */
    eSQL_NOTROWVARCOL              =  -15115, /**< Identifier is not a column of the specified row variable. */
    eSQL_NOTBLOCKVAR               =  -15116, /**< Identifier is not declared in specified block. */
    eSQL_TOOMANYROWVARS            =  -15117, /**< Only one row variable can be declared for a cursor. */
    eSQL_WRONGROWVAR               =  -15118, /**< Row variable is not declared for this cursor. */
    eSQL_LABELNOTFOUND             =  -15119, /**< Statement with specified label not found. */
    eSQL_FORCURSOR                 =  -15120, /**< Statement not allowed on FOR cursor name. */
    eSQL_ARGREF                    =  -15121, /**< Procedure/function argument not found. */
    eSQL_BADARGFORM                =  -15122, /**< Invalid procedure/function argument specification. */
    eSQL_PREPVAROUT                =  -15123, /**< PREPARE statement variable cannot be an OUT variable. */
    eSQL_PREPVARROW                =  -15124, /**< PREPARE statement variable cannot be a ROW variable. */
    eSQL_PREPVARTYPE               =  -15125, /**< PREPARE statement variable must be a CHAR type. */
    eSQL_BADINTOVARTYPE            =  -15126, /**< EXECUTE INTO variable type is not assignable. */
    eSQL_DUPPREPNAME               =  -15127, /**< Duplicate PREPARE statement name. */
    eSQL_PREPNOTFOUND              =  -15128, /**< PREPARE statement not found. */
    eSQL_PREPNOPARAMS              =  -15129, /**< Parameter markers are not allowed in PREPARE statement. */
    eSQL_PREPNOTSELECT             =  -15130, /**< PREPARE statement must be a SELECT for EXECUTE INTO. */
    eSQL_EXECNEEDSINTO             =  -15131, /**< EXECUTE must have INTO clause for a PREPARE of SELECT statement. */
    eSQL_PREPUNALLOWABLE           =  -15132, /**< Statement type not allowed in PREPARE. */
    eSQL_PREPNOCOLS                =  -15133, /**< PREPARE SELECT number of result columns does not match EXECUTE INTO. */
    eSQL_NOTCONDITION              =  -15134, /**< Referenced variable is not a named condition. */
    eSQL_GENEXCEPTION              =  -15135, /**< Cannot mix general and specific conditions in one handler. */
    eSQL_DUPCONDITION              =  -15136, /**< Duplicate condition spec'd in same handler or other handler in same scope. */
    eSQL_UNDONOTATOMIC             =  -15137, /**< BEGIN must specify ATOMIC within an UNDO handler. */
    eSQL_HANDLERNOTFOUND           =  -15138, /**< Handler not found for condition. */
    eSQL_RESIGNAL                  =  -15139, /**< Resignal when handler not active. */
    eSQL_INVDIAGITEM               =  -15140, /**< Invalid diagnostics item info name. */
    eSQL_MSGTEXT                   =  -15141, /**< MESSAGE_TEXT expected. */
    eSQL_NODIAGSINFO               =  -15142, /**< No diagnostics info is available. */
    eSQL_INVCONDNUM                =  -15143, /**< Invalid condition number. */
    eSQL_MAXDIAGSAREA              =  -15144, /**< Maximum number of stacked diagnostics areas exceeded. */
    eSQL_DIAGNOTSTACKED            =  -15145, /**< Stacked diagnostics accessed without active handler. */
    eSQL_PROCEXISTS                =  -15146, /**< Another stored procedure/function with same name has been created. */
    eSQL_TRMODE                    =  -15147, /**< Transaction mode can be specified only once. */
    eSQL_BEGINTRANS                =  -15148, /**< BEGIN TRANSACTION can only be specified with first BEGIN. */
    eSQL_ATOMIC                    =  -15149, /**< Statement cannot be used in a BEGIN ATOMIC/TRANSACTION block. */
    eSQL_MODIFIES                  =  -15150, /**< Read only stored proc/func contains modification statements. */
    eSQL_SYSCAT                    =  -15151, /**< Invalid operation on SYSTEM CATALOG. */
    eSQL_SQLSTATESIGNAL            =  -15152, /**< Unhandled signaled SQLSTATE condition. */
    eSQL_NOTDETERMINISTIC          =  -15153, /**< Simple CASE expression cannot call a non-deterministic function. */
    eSQL_LEAVEHANDLER              =  -15154, /**< LEAVE to a block outside of a condition handler is not allowed. */
    eSQL_ASGTEXPRCOUNT             =  -15155, /**< Number of variables in multiple SET assignment does not match number of expressions. */
    eSQL_NOTINFORLOOP              =  -15156, /**< COMMIT/ROLLBACK not allowed in FOR loop. */
    eSQL_DUPLICATELABEL            =  -15157, /**< Duplicate block or loop label. */
    eSQL_CALLFUNCTION              =  -15158, /**< Functions cannot be called using the CALL statement. */
    eSQL_TRIGDBMISMATCH            =  -15159, /**< Table's database name does not match trigger's. */
    eSQL_TRIGCOLLIST               =  -15160, /**< Column list can only be used with UPDATE triggers. */
    eSQL_BEGINATOMIC               =  -15161, /**< A compound trigger action must be BEGIN ATOMIC. */
    eSQL_TRIGEXISTS                =  -15162, /**< Another trigger with same name has been created. */
    eSQL_WHENFCN                   =  -15163, /**< Functions ref'd in WHEN clause cannot be MODIFIES SQL. */
    eSQL_NOTINTRIGGER              =  -15164, /**< Transactions cannot be used in a trigger. */
    eSQL_NOTRIG                    =  -15165, /**< Trigger not found. */
    eSQL_NOINSERTVALS              =  -15166, /**< Syntax error where no columns are present after the keyword 'VALUES'. */
    eSQL_DEFINSERTVALS             =  -15167, /**< Syntax error where columns are present after 'DEFAULT VALUES'. */
    eSQL_INVARRAYTYPE              =  -15168, /**< Invalid array element value. */
    eSQL_NOTARRAY                  =  -15169, /**< Not an array value/column/variable. */
    eSQL_BADSUBSCRIPT              =  -15170, /**< Subscript value is out of range. */
    eSQL_INVARRAYOP                =  -15171, /**< Invalid array operation. */
    eSQL_RECURSIVEPROC             =  -15172, /**< Recursive stored procedures and triggers are not allowed. */
    eSQL_TBD                       =  -15173, /**< Yet to be implemented feature. */
    eSQL_SYSTEM                    =  -15174, /**< System error. */

    /* mirroring codes: */
    eMIR_SYNC_GENERROR             =  -16000, /**< Generic synchronous mirroring error. */
    eMIR_SYNC_TIMEOUT              =  -16001, /**< Synchronous mirroring timeout. */
    eMIR_INVLOGFILE                =  -16002, /**< Invalid log file format. */

    /* rdbc codes: */
    eRDBC_BADCTYPE                 =  -17000, /**< Invalid C data type. */
    eRDBC_BADSTYPE                 =  -17001, /**< Invalid SQL data type. */
    eRDBC_NOMEMORY                 =  -17002, /**< Driver out of memory. */
    eRDBC_TYPEATTR                 =  -17003, /**< Data type attribute violation. */
    eRDBC_NOTCAPABLE               =  -17004, /**< Driver not capable. */
    eRDBC_DESCRANGE                =  -17005, /**< Invalid descriptor field identifier. */
    eRDBC_INVDESCIDX               =  -17006, /**< Invalid descriptor index. */
    eRDBC_NOTCURSOR                =  -17007, /**< Prepared statement is not a valid cursor. */
    eRDBC_INVIRDMOD                =  -17008, /**< Cannot modify an implementation row descriptor. */
    eRDBC_INVOPENMODE              =  -17009, /**< Invalid database open mode. */
    eRDBC_OPTIONRANGE              =  -17010, /**< Invalid attribute/option identifier. */
    eRDBC_NOINDVAR                 =  -17011, /**< Indicator variable required but not supplied. */
    eRDBC_CLOSEHDBC                =  -17012, /**< Connection not closed. */
    eRDBC_OPENHDBCS                =  -17013, /**< Must free all connection handles first. */
    eRDBC_AUTODESCR                =  -17014, /**< Invalid use of implicit descriptor handle. */
    eRDBC_ATTRVALUE                =  -17015, /**< Invalid attribute value. */
    eRDBC_FCNRANGE                 =  -17016, /**< Function type out of range. */
    eRDBC_INVOPNOW                 =  -17017, /**< Invalid operation at this time. */
    eRDBC_BADDESCINFO              =  -17018, /**< Inconsistent descriptor information. */
    eRDBC_CONCATNULL               =  -17019, /**< Attempt to concatenate a null value. */
    eRDBC_COLRANGE                 =  -17020, /**< Column type out of range. */
    eRDBC_SCOPERANGE               =  -17021, /**< Scope out of range. */
    eRDBC_NULLRANGE                =  -17022, /**< Nullable type out of range. */
    eRDBC_UNIQUERANGE              =  -17023, /**< Uniqueness option type out of range. */
    eRDBC_ACCURANGE                =  -17024, /**< Accuracy option type out of range. */

    /* tx codes: */
    eTX_DISABLED                   =  -18000, /**< HTTP listener is disabled. */
    eTX_TRUNCATED                  =  -18001, /**< Data retrieved had to be truncated. */
    eTX_NETREAD                    =  -18002, /**< Failure to read data from network. */
    eTX_NETWRITE                   =  -18003, /**< Failure to write data to network. */
    eTX_CONNECT                    =  -18004, /**< Failed to connect to server. */
    eTX_HOSTNAME                   =  -18005, /**< Host name not found. */
    eTX_ACCEPT                     =  -18006, /**< TCP/IP accept failure. */
    eTX_LISTEN                     =  -18007, /**< TCP/IP listen failure. */
    eTX_NO_REMOTE                  =  -18008, /**< Remote connections not allowed. */
    eTX_GENERROR                   =  -18009, /**< Generic TX error. */

    /* system codes: */
    eSYS_BADERRCODE                =  -20000, /**< Invalid rdm RETCODE value. */
    eSYS_ERRACTIVE                 =  -20001, /**< Error function call not allowed when another error is active. */
    eSYS_ERRCATCH                  =  -20002, /**< Attempt to pop a catch off an empty catch stack. */
    eSYS_DCHAIN                    =  -20003, /**< Bad dchain. */
    eSYS_BADTREE                   =  -20004, /**< B-tree malformed. */
    eSYS_BADHASH                   =  -20005, /**< Hash malformed. */
    eSYS_KEYEXIST                  =  -20006, /**< Key value already exists. */
    eSYS_BADOPTKEY                 =  -20007, /**< Calculating optkey index. */
    eSYS_BADFREE                   =  -20008, /**< Attempt to free empty table. */
    eSYS_ERROR                     =  -20009, /**< Unexpected system error. */
    eSYS_NOSQLSTATE                =  -20010, /**< Unexpected empty SQL state. */

    /* http codes: */
    eHTTP_BADREQUEST               =  -21000, /**< Bad HTTP requst. */
    eHTTP_URITOOLONG               =  -21001, /**< URI too long. */
    eHTTP_ENTTOOLARGE              =  -21002, /**< Entity too large. */
    eHTTP_NOLENGTH                 =  -21003, /**< No length was specified. */
    eHTTP_INVHANDLE                =  -21004, /**< Invalid HTTP handle. */
    eHTTP_INVURLARGFMT             =  -21005, /**< Invalid argument format in URL. */
    eHTTP_BADUSERID                =  -21006, /**< Invalid user id - not alphanumeric. */

    /* q/a codes: */
    eQA_ILLEGAL_TFS_COMBINATION    =  -29000, /**< Illegal combination of options for different tfs types. */
    eQA_TEST_TIMEOUT               =  -29001, /**< Test timed out. */
    eQA_ILLEGAL_FILENAME           =  -29002, /**< Illegal filename. */
    eQA_ILLEGAL_NAMESPACE          =  -29003, /**< Illegal namespace. */
    eQA_FEATURE_NOTIMPLEMENTED     =  -29004, /**< Feature have not been implemented. */
    eQA_ILLEGAL_USE_OF_STOP_WATCH  =  -29005, /**< Illegal use of stop watch. */
    eQA_HAS_FLOAT_REQUIRED         =  -29006, /**< Illegal use of floating point. */
    eQA_CASE_FAILED                =  -29007, /**< A test case failed. */
    eQA_NEED_DESCRIPTION           =  -29008, /**< A description is missing for a case. */
    eQA_HELP                       =  -29009, /**< Help text returned. */
    eQA_MISSING_ARGUMENT           =  -29010, /**< Command line option is missing an argument. */
    eQA_NO_TESTS_SELECTED          =  -29011, /**< No tests was selected by the command line options given. */
    eQA_CASE_DESCRIBED             =  -29012, /**< T test case have been described. */
    eQA_LOG_BAD_READ               =  -29013, /**< Reading from test log failed. */
    eQA_LOG_BAD_WRITE              =  -29014, /**< Writing to test log failed. */
    eQA_LOG_OPEN                   =  -29015, /**< Opening test log failed. */
    eQA_TFS_PROPERTY_CONFLICT      =  -29016, /**< TFS property have not been set. */
    eQA_TFS_PROPERTY_UNSET         =  -29017, /**< TFS property set inconsistently. */
    eQA_NO_GLOBAL_ENC              =  -29018, /**< There is no global encryption support for legacy. */
    eQA_FORK                       =  -29019, /**< Failed to fork child process. */
    eQA_MMAP                       =  -29020, /**< Failed to create shared memory. */
    eQA_KILL                       =  -29021, /**< The QA Framework detected termination upon a signal while running a test in a child process. */
    eQA_CHILD_EXIT                 =  -29022, /**< A forked child is done, now we need to cleanup and exit.  No summary output.. */
    eQA_END_OF_LIST                =  -29023, /**< Used internally to end a list of error or status codes to the QA_S macro. */
    eQA_RDBC_INVHANDLE             =  -29024, /**< A placeholder for 'SQL_INVALID_HANDLE'. */
    eQA_RDBC_ERROR                 =  -29025, /**< A placeholder for 'SQL_ERROR'. */
    eQA_TEST_FAILED                =  -29026, /**< Some tests failed. */

    /* embed codes: */
    eEMBED_FILE_NOT_FOUND          =  -30000, /**< File not found by the embedder. */
    eEMBED_UNKNOWN_COMMAND         =  -30001, /**< Command not supported by the embedder. */
    eEMBED_ILLEGAL_NAMESPACE       =  -30002, /**< Illegal namespace provided to the embedder. */
    eEMBED_CONTENT_MISMATCH        =  -30003 /**< Content doesn't match the embedded hash for the file. */
} RDM_RETCODE;

#define RDM_IS_ERROR(c) ((int32_t) (c) < 0 ? 1 : 0) /**< Is the return code an error code */
#define RDM_IS_INFO(c) ((int32_t) (c) >= 0 ? 1 : 0) /**< Is the return code an info code */
/**
 *  @}
 */

#endif  /* RDMRETCODETYPES_H_INCLUDED_ */
